#ifndef __CHUAN12864_H__
#define __CHUAN12864_H__

#include<msp430g2553.h>
#include"math.h"

#define uint unsigned int
#define uchar unsigned char
#define ulong unsigned long

#define CPU_F ((double)8000000)
#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0))
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0))

#define SID  BIT1
#define SCLK BIT0
//#define CS   BIT5
//define PSB  BIT0
#define LCDPORT P1OUT

#define SID_1  LCDPORT |= SID
#define SID_0  LCDPORT &= ~SID

#define CS_1   LCDPORT |= CS
#define CS_0   LCDPORT &= ~CS


#define SCLK_1 LCDPORT |= SCLK
#define SCLK_0 LCDPORT &= ~SCLK



/***********************************************************
*    ƣLCD_Write_cmd()
*    ܣдһLCD12864
*ڲcmd:д޷ֽʽ
*ڲ
*˵    дʱRW=0RS=0 չ24λз
*    ʽ11111 RW RS 0   xxxx0000    xxxx0000
*          |ߵֽ  |bit7~4|bit3~0|
***********************************************************/
void LCD_write_com(uchar cmd)
{
  uchar i,high4bits,low4bits;
  ulong lcdcmd;
  high4bits = cmd & 0xf0;
  low4bits = (cmd<<4)&0xf0;
  lcdcmd=((ulong)0xf8<<16)+((ulong)high4bits<<8)+(ulong)low4bits;
 // CS_1;
  SCLK_0;
  for(i=0;i<24;i++)
  {
    SID_0;
    if(lcdcmd & 0x00800000)
    {
      SID_1;
    }
    lcdcmd <<=1;
    SCLK_1;
   // delay_us(1);
    SCLK_0;
  }
 // CS_0;
}

/***********************************************************
*    ƣLCD_Write_Byte()
*    ܣLCD12864дһֽ
*ڲbyte:дַ޷ʽ
*ڲ
*    LCD_Write_Byte('F') //дַ'F'
***********************************************************/
void LCD_write_data(uchar byte)
{
  uchar i,high4bits,low4bits;
  ulong lcddat;
  high4bits = byte & 0xf0;
  low4bits = (byte<<4)&0xf0;
  lcddat=((ulong)0xfa<<16)+((ulong)high4bits<<8)+(ulong)low4bits;
 // CS_1;
  for(i=0;i<24;i++)
  {
    SID_0;
    if(lcddat & 0x00800000)
    {
      SID_1;
    }
    lcddat <<=1;
    SCLK_1;
  //  delay_us(1);
    SCLK_0;
  }
 // CS_0;
}
/***********************************************************
*    ƣLCD_Write_data(uchar add,)
*    ܣʾ
*ڲbyte:дַ޷ʽ
*ڲ
*    LCD_Write_data(0x80,"")
***********************************************************/
void LCD_Write_data(uchar addr,uchar *hz)
{
	LCD_write_com(addr);
        delay_ms(5);
	while(*hz != '\0')
	{
		LCD_write_data(*hz);
		hz++;
                delay_ms(5);
	}
}

//***********************************************************************
//	ʾʾ
//***********************************************************************

void LCD_clear(void)
{
	LCD_write_com(0x01);
	delay_us(50);
}

/****************************************************/
//LCD12864ʼ
/****************************************************/
void LCD_Init()
{
 // P5OUT &= ~BIT3;        //λLCD12864
 // delay_ms(50); //50ms
 // P5OUT |= BIT3;
  P1DIR |= 0x03;
  P1OUT |= 0x03;

  LCD_clear();
  delay_ms(50);
   LCD_write_com(0x34);    //ָ
  delay_us(150);  //150us
  LCD_write_com(0x30);    //ָ
  delay_us(150);  //150us
  LCD_write_com(0x30);
  delay_us(50);   //50us
   LCD_write_com(0x0c);    //ʾ
  delay_us(150);  //150us
  LCD_write_com(0x01);      //lcdʾ
  delay_ms(12);//12ms
  LCD_write_com(0x06);
  delay_us(10);  //10us
  LCD_write_com(0x02);      //ַλ
  delay_us(10);  //10us
}

/***********************************************************
*    ƣLCD_pos()
*    ܣҺʾλ
*ڲx:ڼУ1~4Ӧ1~4
*          y:ڼУ0~15Ӧ1~16
*ڲ
*    set_cursor(2,3) //ڶУ
***********************************************************/

void set_cursor(uchar x, uchar y)
{
    unsigned char i;
    switch(x)                   				//ȷк
    {
        case 0x00: i=0x80; break;       		//һ
        case 0x01: i=0x90; break;       		//ڶ
        case 0x02: i=0x88; break;       		//
        case 0x03: i=0x98; break;       		//
        default : break;
    }
    i = y+i;                    				//ȷк
    LCD_write_com(i);
}
//************************************************
//ʾַ
//*************************************************

void display_string(uchar x,uchar y,uchar *Alphabet)
{
    set_cursor(x,y);                //ʾʼַ
        delay_ms(5);                                     //430˵ʱҪ
    while(*Alphabet!='\0')
    {
        LCD_write_data(*Alphabet);          //дҪʾַʾ
        Alphabet++;
                delay_ms(5);                                 //430˵ʱҪ
    }
}
/***********************************************************
*    ƣLCD_flash()
*    ܣLCD˸
*ڲtimes:Ļ˸Ĵ 1~255
*ڲ
*˵    ˸Ϊ800ms
***********************************************************/
void LCD_flash(uchar times)
{
 while(times>0)
  {
    LCD_write_com(0x08);
    delay_us(400);
    LCD_write_com(0x0C);
    delay_us(400);
    --times;
  }
}

//***********************************************************************
//	
//***********************************************************************
/*void Draw_dots(uchar x,uchar y)
{
   uchar row,xlabel,xlabel_bit;
   uchar read_h=0,read_l=0;
   LCD_write_com(0x34);
   delay(10);

   xlabel= x>>4;
   xlabel_bit= x & 0x0f;

   if(y<32)
   {
      row=y;
    }
   else
   {
      row=y-32;
      xlabel += 8;
   }
   LCD_write_com(0x80+row);
   delay(10);
   LCD_write_com(0x80+xlabel);
   delay(10);


   if(xlabel_bit<8)
   {
       read_h|=((0x01<<(7-xlabel_bit)));
       LCD_write_data(read_h);
       delay(10);
       LCD_write_data(read_l);
       delay(10);
   }
   else
   {
       read_l|=((0x01<<(15-xlabel_bit)));
       LCD_write_data(read_h);
       delay(10);
       LCD_write_data(read_l);
       delay(10);
   }
   LCD_write_com(0x36);
   delay(10);
   LCD_write_com(0x30);
   delay(10);
}*/
/*******************************************
    ܣҺGDRAMڲ
********************************************/
/*void Clear_GDRAM(void)
{
    uchar i,j,k;

    LCD_write_com(0x34);
    delay(10);

	i = 0x80;
	for(j = 0;j < 32;j++)
	{
          LCD_write_com(i++);
          delay(10);
          LCD_write_com(0x80);
          delay(10);
          for(k = 0;k < 16;k++)
          {
            LCD_write_data(0x00);
            delay(10);
          }
	}
	i = 0x80;
 	for(j = 0;j < 32;j++)
	{
 	        LCD_write_com(i++);
                delay(10);
                LCD_write_com(0x88);
                delay(10); 	
  		for(k = 0;k < 16;k++)
  		{
   		    LCD_write_data(0x00);
                    delay(10);
   		}
	}
    LCD_write_com(0x36);
    delay(10);
    LCD_write_com(0x30);
    delay(10);
}*/
void clear_flag()
{
  delay_us(50);
  LCD_write_com(0x87);
  delay_us(50);
  LCD_write_data(0x20);
  delay_us(50);
  LCD_write_com(0x97);
  delay_us(50);
  LCD_write_data(0x20);
  delay_us(50);
  LCD_write_com(0x8f);
  delay_us(50);
  LCD_write_data(0x20);
  delay_us(50);
  LCD_write_com(0x9f);
  delay_us(50);
  LCD_write_data(0x20);
  delay_us(50);
}

void SetALineReverse(uchar m)
{
  switch(m)
  {
   case 1:clear_flag();LCD_write_com(0x80);delay_us(50);LCD_write_data(0x10);break;
   case 2:clear_flag();LCD_write_com(0x90);delay_us(50);LCD_write_data(0x10);break;
   case 3:clear_flag();LCD_write_com(0x88);delay_us(50);LCD_write_data(0x10);break;
   case 4:clear_flag();LCD_write_com(0x98);delay_us(50);LCD_write_data(0x10);break;
  }
}

#endif